/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the OrganizationMutableLifecycleSettings type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &OrganizationMutableLifecycleSettings{}

// OrganizationMutableLifecycleSettings struct for OrganizationMutableLifecycleSettings
type OrganizationMutableLifecycleSettings struct {
	UpdateStatus string `json:"update_status"`
	RegularCustomer []CustomerEngagementSection `json:"regular_customer"`
	ChurnRiskCustomer []CustomerEngagementSection `json:"churn_risk_customer"`
	ChurnedCustomer []CustomerEngagementSection `json:"churned_customer"`
	LastChangeAt time.Time `json:"last_change_at"`
}

// NewOrganizationMutableLifecycleSettings instantiates a new OrganizationMutableLifecycleSettings object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewOrganizationMutableLifecycleSettings(updateStatus string, regularCustomer []CustomerEngagementSection, churnRiskCustomer []CustomerEngagementSection, churnedCustomer []CustomerEngagementSection, lastChangeAt time.Time) *OrganizationMutableLifecycleSettings {
	this := OrganizationMutableLifecycleSettings{}
	this.UpdateStatus = updateStatus
	this.RegularCustomer = regularCustomer
	this.ChurnRiskCustomer = churnRiskCustomer
	this.ChurnedCustomer = churnedCustomer
	this.LastChangeAt = lastChangeAt
	return &this
}

// NewOrganizationMutableLifecycleSettingsWithDefaults instantiates a new OrganizationMutableLifecycleSettings object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewOrganizationMutableLifecycleSettingsWithDefaults() *OrganizationMutableLifecycleSettings {
	this := OrganizationMutableLifecycleSettings{}
	return &this
}

// GetUpdateStatus returns the UpdateStatus field value
func (o *OrganizationMutableLifecycleSettings) GetUpdateStatus() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.UpdateStatus
}

// GetUpdateStatusOk returns a tuple with the UpdateStatus field value
// and a boolean to check if the value has been set.
func (o *OrganizationMutableLifecycleSettings) GetUpdateStatusOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdateStatus, true
}

// SetUpdateStatus sets field value
func (o *OrganizationMutableLifecycleSettings) SetUpdateStatus(v string) {
	o.UpdateStatus = v
}

// GetRegularCustomer returns the RegularCustomer field value
func (o *OrganizationMutableLifecycleSettings) GetRegularCustomer() []CustomerEngagementSection {
	if o == nil {
		var ret []CustomerEngagementSection
		return ret
	}

	return o.RegularCustomer
}

// GetRegularCustomerOk returns a tuple with the RegularCustomer field value
// and a boolean to check if the value has been set.
func (o *OrganizationMutableLifecycleSettings) GetRegularCustomerOk() ([]CustomerEngagementSection, bool) {
	if o == nil {
		return nil, false
	}
	return o.RegularCustomer, true
}

// SetRegularCustomer sets field value
func (o *OrganizationMutableLifecycleSettings) SetRegularCustomer(v []CustomerEngagementSection) {
	o.RegularCustomer = v
}

// GetChurnRiskCustomer returns the ChurnRiskCustomer field value
func (o *OrganizationMutableLifecycleSettings) GetChurnRiskCustomer() []CustomerEngagementSection {
	if o == nil {
		var ret []CustomerEngagementSection
		return ret
	}

	return o.ChurnRiskCustomer
}

// GetChurnRiskCustomerOk returns a tuple with the ChurnRiskCustomer field value
// and a boolean to check if the value has been set.
func (o *OrganizationMutableLifecycleSettings) GetChurnRiskCustomerOk() ([]CustomerEngagementSection, bool) {
	if o == nil {
		return nil, false
	}
	return o.ChurnRiskCustomer, true
}

// SetChurnRiskCustomer sets field value
func (o *OrganizationMutableLifecycleSettings) SetChurnRiskCustomer(v []CustomerEngagementSection) {
	o.ChurnRiskCustomer = v
}

// GetChurnedCustomer returns the ChurnedCustomer field value
func (o *OrganizationMutableLifecycleSettings) GetChurnedCustomer() []CustomerEngagementSection {
	if o == nil {
		var ret []CustomerEngagementSection
		return ret
	}

	return o.ChurnedCustomer
}

// GetChurnedCustomerOk returns a tuple with the ChurnedCustomer field value
// and a boolean to check if the value has been set.
func (o *OrganizationMutableLifecycleSettings) GetChurnedCustomerOk() ([]CustomerEngagementSection, bool) {
	if o == nil {
		return nil, false
	}
	return o.ChurnedCustomer, true
}

// SetChurnedCustomer sets field value
func (o *OrganizationMutableLifecycleSettings) SetChurnedCustomer(v []CustomerEngagementSection) {
	o.ChurnedCustomer = v
}

// GetLastChangeAt returns the LastChangeAt field value
func (o *OrganizationMutableLifecycleSettings) GetLastChangeAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.LastChangeAt
}

// GetLastChangeAtOk returns a tuple with the LastChangeAt field value
// and a boolean to check if the value has been set.
func (o *OrganizationMutableLifecycleSettings) GetLastChangeAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.LastChangeAt, true
}

// SetLastChangeAt sets field value
func (o *OrganizationMutableLifecycleSettings) SetLastChangeAt(v time.Time) {
	o.LastChangeAt = v
}

func (o OrganizationMutableLifecycleSettings) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o OrganizationMutableLifecycleSettings) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["update_status"] = o.UpdateStatus
	toSerialize["regular_customer"] = o.RegularCustomer
	toSerialize["churn_risk_customer"] = o.ChurnRiskCustomer
	toSerialize["churned_customer"] = o.ChurnedCustomer
	toSerialize["last_change_at"] = o.LastChangeAt
	return toSerialize, nil
}

type NullableOrganizationMutableLifecycleSettings struct {
	value *OrganizationMutableLifecycleSettings
	isSet bool
}

func (v NullableOrganizationMutableLifecycleSettings) Get() *OrganizationMutableLifecycleSettings {
	return v.value
}

func (v *NullableOrganizationMutableLifecycleSettings) Set(val *OrganizationMutableLifecycleSettings) {
	v.value = val
	v.isSet = true
}

func (v NullableOrganizationMutableLifecycleSettings) IsSet() bool {
	return v.isSet
}

func (v *NullableOrganizationMutableLifecycleSettings) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOrganizationMutableLifecycleSettings(val *OrganizationMutableLifecycleSettings) *NullableOrganizationMutableLifecycleSettings {
	return &NullableOrganizationMutableLifecycleSettings{value: val, isSet: true}
}

func (v NullableOrganizationMutableLifecycleSettings) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOrganizationMutableLifecycleSettings) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


